freeslot(
"MT_PURPLERING",
"sfx_purpr",
"S_PURPLERING",
"SPR_PURP",
"S_PURPLESPARK",
"SPR_PSPK"
)

print("Big thanks to Lfan on the SRB2 Discord for coming in clutch and volunteering to deal with creating the cosmic clones!")
print("A massive part of this addon wouldn'tve even happened if it were not for him!")

mobjinfo[MT_PURPLERING] = {
	spawnstate = S_PURPLERING,
	spawnhealth = 1000,
	deathstate = S_PURPLESPARK,
	deathsound = sfx_purpr,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SLIDEME|MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_PURPLERING] = {
	sprite = SPR_PURP,
	frame = FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 23,
	var2 = 1,
	tics = -1,
	action = A_AttractChase
}

states[S_PURPLESPARK] = {
	sprite = SPR_PSPK,
	frame = FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 8,
	var2 = 1,
	tics = 8,
	nextstate = S_NULL
}

//FUN STUFF BEGINS HERE!

rawset(_G, "purplecoin", true) //PURPLE COIN VARIABLE

COM_AddCommand("purplecoinmode", function(player,arg) //PURPLE COIN COMMAND
	if player.mo and player.mo.valid
		if arg
			if arg == "on" or arg == "1" or arg == "true" then
				purplecoin = true
				print("\x89"+"A Purple Comet has landed!")
			elseif arg == "off" or arg == "0" or arg == "false" then
				print("The stars are pleased by your performance. Good job!")
				purplecoin = false
			else
				CONS_Printf(player,"Invalid Parameter.")
			end
			if arg == nil then
				CONS_Printf(player,"Toggles Purple Coin special stages.")
				CONS_Printf(player,"Options are: on and off.")
			end
		end
	end
end, COM_ADMIN)

local function P_GivePlayerPurpleRings(p, num_spheres)
	if not (p and p.mo) then
		return
	end
	if p.bot then
		p = consoleplayer
	end
	
	p.spheres = p.spheres + num_spheres
	
	min(max(p.spheres, 0), 9999)

end



rawset(_G, "TheRace", mapheaderinfo[gamemap].subttl)

addHook("NetVars", function(net)
	purplecoin = net(purplecoin)
	TheRace = net(TheRace)
end)

addHook("MapLoad", function(mapnum)
	TheRace = mapheaderinfo[gamemap].subttl
end)

hud.add(function(v,player)
	if purplecoin == true and gamestate == GS_LEVEL and G_IsSpecialStage(gamemap) == true then
		if mapheaderinfo[gamemap].typeoflevel&TOL_NIGHTS then
			if player.nightstime > (player.startedtime/2)+TICRATE and player.bonustime != true and gamemap != 56 and gamemap != 57
				v.drawStretched(0,0,2*FRACUNIT,2*FRACUNIT,v.cachePatch("PURPLP"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_SCALEPATCHMASK|V_60TRANS)
			elseif (player.nightstime <= (player.startedtime/2)+TICRATE or gamemap == 56 or gamemap == 57) and player.nightstime > 11*TICRATE or player.bonustime == true and player.nightstime > 11*TICRATE
				v.drawStretched(0,0,2*FRACUNIT,2*FRACUNIT,v.cachePatch("REDDDD"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_SCALEPATCHMASK|V_60TRANS)
			elseif player.nightstime <= 11*TICRATE and player.nightstime != 0 then
				v.drawStretched(0,0,2*FRACUNIT,2*FRACUNIT,v.cachePatch("GOOOOO"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_SCALEPATCHMASK|V_60TRANS)
			elseif player.nightstime <= 0
				v.drawStretched(0,0,2*FRACUNIT,2*FRACUNIT,v.cachePatch("FUUUCK"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_SCALEPATCHMASK)
			end
		else
			if player.nightstime > (mapheaderinfo[gamemap].sstimer/2*TICRATE)+TICRATE and gamemap != 66 and (TheRace != "\137Sphere Race")
				v.drawStretched(0,0,2*FRACUNIT,2*FRACUNIT,v.cachePatch("PURPLP"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_SCALEPATCHMASK|V_60TRANS)
			elseif (player.nightstime <= (mapheaderinfo[gamemap].sstimer/2*TICRATE)+TICRATE or gamemap == 66 or (TheRace == "\137Sphere Race")) and player.nightstime > 11*TICRATE
				v.drawStretched(0,0,2*FRACUNIT,2*FRACUNIT,v.cachePatch("REDDDD"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_SCALEPATCHMASK|V_60TRANS)
			elseif player.nightstime <= 11*TICRATE and player.nightstime != 0 then
				v.drawStretched(0,0,2*FRACUNIT,2*FRACUNIT,v.cachePatch("GOOOOO"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_SCALEPATCHMASK|V_60TRANS)
			elseif player.nightstime <= 0
				v.drawStretched(0,0,2*FRACUNIT,2*FRACUNIT,v.cachePatch("FUUUCK"),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_SCALEPATCHMASK)
			end
		end
	end
end, "game")

addHook("MobjCollide", function(ring1, ring2)
    if ring2.type ~= MT_PURPLERING return end
    if not (ring1.flags2&MF2_NIGHTSPULL or ring2.flags2&MF2_NIGHTSPULL) and ring1.x == ring2.x and ring1.y == ring2.y and ring1.z == ring2.z then
        P_RemoveMobj(ring2)
    end
end, MT_PURPLERING)

addHook("PlayerThink", function(player)
	if purplecoin == true and G_IsSpecialStage(gamemap) == true then
		hud.disable("nightslink")
		hud.disable("nightsrings")
		hud.disable("nightsscore")
		hud.disable("nightstime")
		hud.disable("nightsrecords")
		if mapheaderinfo[gamemap].typeoflevel&TOL_NIGHTS then
			if player.nightstime > (player.startedtime/2)+TICRATE and player.bonustime != true and gamemap != 56 and gamemap != 57
				S_ChangeMusic("purc",true,player)
			elseif ((player.nightstime <= (player.startedtime/2)+TICRATE and gamemap != 56 and gamemap != 57) or player.bonustime == true and gamemap != 56 and gamemap != 57) and player.nightstime > 11*TICRATE
				S_ChangeMusic("puru",true,player)
			elseif player.nightstime <= 11*TICRATE and player.nightstime != 0 and gamemap != 56 and gamemap != 57 then
				S_ChangeMusic("fuck",false,player)
			elseif player.nightstime > (player.startedtime/2)+TICRATE and gamemap == 56 or gamemap == 57
				S_ChangeMusic("redc",true,player)
			elseif player.nightstime <= (player.startedtime/2)+TICRATE and gamemap == 56 or gamemap == 57
				S_ChangeMusic("redu",true,player)
			end
		else
			if player.nightstime > (mapheaderinfo[gamemap].sstimer/2*TICRATE)+TICRATE and gamemap != 66 and (TheRace != "\137Sphere Race")
				S_ChangeMusic("purc",true,player)
			elseif ((player.nightstime <= (mapheaderinfo[gamemap].sstimer/2*TICRATE)+TICRATE and gamemap != 66 and gamemap != 64)) and player.nightstime > 11*TICRATE
				S_ChangeMusic("puru",true,player)
			elseif player.nightstime <= 11*TICRATE and player.nightstime != 0 and gamemap != 66 then
				S_ChangeMusic("fuck",false,player)
			elseif player.nightstime <= 11*TICRATE and player.nightstime != 0 and gamemap != 64 then
				S_ChangeMusic("fuck",false,player)
			elseif player.nightstime > (mapheaderinfo[gamemap].sstimer/2*TICRATE)+TICRATE and gamemap == 66
				S_ChangeMusic("redc",true,player)
			elseif player.nightstime > (200*TICRATE) and (TheRace == "\137Sphere Race")
				S_ChangeMusic("purr",true,player)
			elseif ((player.nightstime <= (mapheaderinfo[gamemap].sstimer/2*TICRATE)+TICRATE and gamemap == 66)) and player.nightstime > 11*TICRATE
				S_ChangeMusic("redu",true,player)
			elseif ((player.nightstime <= (200*TICRATE) and (TheRace == "\137Sphere Race"))) then
				S_ChangeMusic("pura",true,player)

			end
		end
	elseif purplecoin == false and G_IsSpecialStage(gamemap) == true then
		hud.enable("nightslink")
		hud.enable("nightsrings")
		hud.enable("nightsscore")
		hud.enable("nightstime")
		hud.enable("nightsrecords")
	end
end)

addHook("MapThingSpawn", function(mobj,mapthing)
	if purplecoin == true then
		P_SpawnMobjFromMobj(mobj,0,0,0,MT_PURPLERING)
		P_RemoveMobj(mobj)
		return true
	else
		return false
	end
end, MT_BLUESPHERE)

addHook("TouchSpecial", function(special, toucher)
	if special and special.valid
	and toucher and toucher.valid
	and toucher.player and toucher.player.valid
		P_GivePlayerPurpleRings(toucher.player, 1)
	end
end, MT_PURPLERING)

addHook("MusicChange", function(oldname, newname, mflags, looping, position, prefadems, fadeinms)
	
	if purplecoin == true and gamestate == GS_LEVEL and G_IsSpecialStage(gamemap) == true then
		if newname == "_drown" then
			S_ChangeMusic("fuck", false, player, 0, muspos)
			return true
		end
	end
end)